function [dk, db] = bpCNN2CNN2(dbnxt, knxt, x, y)
% y = encode(x)
% z = encode(y)
% k: the current kernel
% knxt: the kernel of next layer

[mx, nx] = size(x);
[my, ny] = size(y);
mk = mx-my+1;
nk = nx-ny+1;

[mz, nz] = size(dbnxt);
[mknxt, nknxt] = size(knxt);
dE = zeros(size(y));
for i=1:my
    for j=1:ny
        rlb = max(1, i-mknxt+1);
        rub = min(i, mz); 
        clb = max(1, j-nknxt+1);
        cub = min(j, nz);
        dE(i,j) = sum(sum(dbnxt(rlb:rub, clb:cub) .* knxt((i-rlb+1):-1:(i-rub+1), (j-clb+1):-1:(j-cub+1))));        
    end
end

db = dE .* (y>0);
dk = zeros(mk, nk);
for i=1:mk
    for j=1:nk
        dk(i,j) = sum(sum(dE .* (y>0) .* x(i+(1:my)-1, j+(1:ny)-1)));
    end
end
end 