clc;
clear;

height = 1504;
width = 1400;   % image size
xsft = 0;
ysft = 8;       % shift of small image
xstp = 50;
ystp = 62;      % size of small image
rows = floor(height/ystp);
cols = floor(width/xstp);

% read training images
sam = zeros(10, rows*cols, ystp, xstp);
nsam = zeros(1,10);
for num=0:9
    imgfile = strcat('../samples/', num2str(num), '/digits', num2str(num), '-1.png');
    img = imread(imgfile);
    for i=(ystp+ysft):ystp:height
        for j=(xstp+xsft):xstp:width
            x = img((i-ystp+1):i, (j-xstp+1):j);
            borders = sum(x(1,:)) + sum(x(ystp,:)) + sum(x(:,1)) + sum(x(:,xstp));
            if sum(sum(x))==0 || borders>0
                continue;
            else
                nsam(num+1) = nsam(num+1) + 1;
                sam(num+1, nsam(num+1), :, :) = x;                
            end            
        end
    end
end

eta = 1e-6; %input('Learning Rate: ');
m = [xstp*ystp 1024 512 10]; %input('Node Numbers for Each Layer: ');
h = length(m) - 2;
nx = m(1);
ny = m(h+2); % Number of Classes

z = zeros(h+2, max(m)); % all nodes
w = rand(h+1, max(m), max(m)) - 0.5; % all weights
b = rand(h+1, max(m)) - 0.5;

% training
for its=1:min(nsam)
    tic;
    for num=0:9
        t = zeros(1,ny);
        t(num+1) = 1e3; % target output
        z(1,(1:nx)) = reshape(sam(num+1,its,:,:), [1,nx]);
        while 1
            z = encodeReLU(z, w, b, m);
            y = z(h+2,(1:ny)); % actual output
            disp(y);
            if mse(y-t)<1e-2
                break;
            else
                [dw, db] = bpReLU(z, w, m, t);
                w = w - eta*dw;
                b = b - eta*db;
            end
        end
    end
    toc;  
end

% test
nerrs = zeros(1,10);
for num=1:9
    imgfile = strcat('../samples/', num2str(num), '/digits', num2str(num), '-2.png');
    img = imread(imgfile);
    for i=(ystp+ysft):ystp:height
        for j=(xstp+xsft):xstp:width
            x = img((i-ystp+1):i, (j-xstp+1):j);
            if sum(sum(x))==0
                continue;
            else
                z(1,(1:nx)) = reshape(x,[1,nx]); 
                z = encode(z, w, b, m);
                y = z(h+2,(1:ny)); % actual output
                [M,I] = max(y);
                if I~=num+1
                    nerrs(num+1) = nerrs(num+1) + 1;
                end
            end
        end
    end
end